///////////////////////////////////////////// 
//        RemoteXY include library         // 
///////////////////////////////////////////// 

/* RemoteXY select connection mode and include library */ 
#define REMOTEXY_MODE__SOFTWARESERIAL 
#include <SoftwareSerial.h> 
#include <RemoteXY.h> 

/* RemoteXY connection settings */ 
#define REMOTEXY_SERIAL_RX 2 
#define REMOTEXY_SERIAL_TX 3 
#define REMOTEXY_SERIAL_SPEED 9600 

/* RemoteXY configurate  */ 
unsigned char RemoteXY_CONF[] = 
  { 0,11,27,0,1,5,67,0,24,23
  ,54,16,2,11,129,0,23,12,39,9
  ,0,84,101,109,112,44,32,194,176,67
  ,0 }; 
   
/* this structure defines all the variables of your control interface */ 
struct { 

    /* output variable */
  char text_1[11];  /* string end zero UNICODE */

    /* other variable */
  unsigned char connect_flag;  /* =1 if wire connected, else =0 */

} RemoteXY; 

///////////////////////////////////////////// 
//           END RemoteXY include          // 
///////////////////////////////////////////// 

/* первое замеренное значение - первая точка */
#define SENS_1_VAL 514
#define SENS_1_TMP 36.6

/* второе замеренное значение - вторая точка */
#define SENS_2_VAL 580
#define SENS_2_TMP 25.0

void setup()  
{ 
  RemoteXY_Init ();  
   
  Serial.begin(9600);   
} 

void loop()  
{  
  RemoteXY_Handler (); 

  /* получаем значение АЦП */
  int sensorValue = analogRead(A5);    
  /* вычисляем текущую температуру используя линейную интерполяцию по двум известным точкам */
  double temp = SENS_1_TMP + (SENS_2_TMP - SENS_1_TMP) / 
                (SENS_2_VAL - SENS_1_VAL) * (sensorValue - SENS_1_VAL);    
  /* преобразуем значение температуры в строку и помещаем ее сразу в поле text_1 структуры RemoteXY */
  dtostrf(temp, 0, 1, RemoteXY.text_1);
  
  /* отправляем значение  АЦП в UART для того что бы мы могли проверить значения */
  Serial.println(sensorValue);
  delay(1);       
}
